;
;	>>> Silly Things by JAC! <<<
;
;	Created 2010-10-10/2010-12-09 for the Sillyventure 2010 in Gdansk.
;
;	This is the test frame for the "Silly-MPT-Sound.bin".

; Sound equates from compiling
mpt_sound_start		= $0200
mpt_player.init 	= $1365
mpt_player.play		= $137D
mpt_player.volume	= $1747
mpt_player.pozptr	= $13E6
mpt_player.pozsng	= $1409
mpt_sound_end		= $178c

cnt	= $1f

;===============================================================

	opt h+l+

	org $2000

	icl "../Silly-Kernel-Equates.asm"
	icl "../Silly-Kernel.asm"

start	jsr init
	jmp play

;===============================================================

	.proc init
	sei
	lda #0
	sta $d40e
	sta $d20e

	copy_memory sound mpt_sound_start (mpt_sound_end-mpt_sound_start+1)

	jsr mpt_player.init
	rts
	.endp

;===============================================================

	.proc play
loop	lda #15
wait	cmp $d40b
	bne wait
	sta $d40a
	sta $d40a
	lda #14
	sta $d01a
	lda $d40b
	sta vcount_start

	jsr mpt_player.play
	lda $d40b
	sta vcount_end

nomore	lda #0
	sta $d01a

	sec
	lda vcount_end
	sbc vcount_start
	sta current_time
	cmp max_time
	bcc no_max
	sta max_time
no_max
	ldy #2
	lda current_time
	jsr print_time
	iny
	lda max_time
	jsr print_time
	jmp loop
	.endp

;===============================================================

	.proc print_time
	ldx #$10
print_tens
	cmp #10
	bcc print_ones
	sbc #10
	inx
	bne print_tens

print_ones
	ora #$10
	pha
	txa
	sta (88),y
	iny
	pla
	sta (88),y
	iny	
	rts
	.endp

;===============================================================

vcount_start	.byte 0
vcount_end	.byte 0
current_time	.byte 0
max_time	.byte 0
	
sound	ins "Silly-MPT-Sound.bin"

	run start

